package com.ruoyi.web.controller.dragForm;

import com.ruoyi.common.annotation.Anonymous;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.domain.entity.SysUser;
import com.ruoyi.common.core.domain.model.LoginUser;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.system.entity.CommonEntity;
import com.ruoyi.system.entity.TableSql;
import com.ruoyi.system.service.ICommonService;
import com.ruoyi.system.service.ITableSqlService;
import dm.jdbc.filter.stat.util.JSONUtils;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Anonymous
@RestController
@RequestMapping("/dragform/common")
public class CommonController extends BaseController {

    @Resource
    private ICommonService commonService;

    @Resource
    private ITableSqlService iTableSqlService;

    /**
     * 查询
     */
    @GetMapping("/selectList")
    public TableDataInfo selectList(CommonEntity commonEntity) {
        startPage();
        return getDataTable(commonService.selectList(commonEntity.getFormMap()));
    }


    @GetMapping("/test")
    public List<CommonEntity> test(@RequestParam String tableName) {
        Map<String, Object> map = new HashMap<>();
        map.put("tableName", tableName);
        //  df_name
        List<CommonEntity> commonEntities = commonService.selectList(map);
        commonEntities.forEach(item->{
            System.out.println(item.getRetMap());
        });


        return commonEntities;
    }

    /**
     * 批量新增
     */
    @PostMapping("/batchInsert")
    public AjaxResult batchInsert(@RequestBody Map<String, Object> map) {
        return toAjax(commonService.batchInsert(map));
    }

    /**
     * 修改
     */
    @PutMapping("/edit")
    public AjaxResult edit(@RequestBody Map<String, Object> map) {
        return toAjax(commonService.edit(map));
    }

    /**
     * 批量删除
     */
    @DeleteMapping("/batchDelete")
    public AjaxResult batchDelete(@RequestBody Map<String, Object> map) {
        return toAjax(commonService.batchDelete(map));
    }

    @GetMapping("/getTableList")
    public TableDataInfo queryTableList(CommonEntity commonEntity) {
        TableSql tableSql = iTableSqlService.selectTableSqlByTSqlKey(commonEntity.getFormMap().get("SQLKEY").toString());
        startPage();  // 校验是否sqlserver 否执行 是执行另一种方式的分页
        return getDataTable(commonService.queryTableList(commonEntity, tableSql));
    }

    @GetMapping("/export")
    public void export(HttpServletResponse response,@RequestParam("tableName") String tableName,@RequestParam("sqlKey") String sqlKey) throws Exception {
        commonService.export(response,tableName,sqlKey);
    }

}
